'use strict';

var _slicedToArray = require('babel-runtime/helpers/sliced-to-array')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _this = this;

var _fsPromise = require('fs-promise');

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _showdownCommands = require('../showdown/commands');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _utils = require('./utils');

var _room = require('./room');

var _room2 = _interopRequireDefault(_room);

var ADDRESS = '127.0.0.1';
var PORT = 0xCF1C;

before(function before() {
    var CONFIG_FILE, EXAMPLE_CONFIG_FILE, config;
    return _regeneratorRuntime.async(function before$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                CONFIG_FILE = './showdown/config/config.js';
                EXAMPLE_CONFIG_FILE = './showdown/config/config-example.js';
                config = undefined;
                context$1$0.prev = 3;

                config = require('.' + CONFIG_FILE);
                context$1$0.next = 22;
                break;

            case 7:
                context$1$0.prev = 7;
                context$1$0.t0 = context$1$0['catch'](3);

                if (!(context$1$0.t0.code !== 'MODULE_NOT_FOUND')) {
                    context$1$0.next = 11;
                    break;
                }

                throw context$1$0.t0;

            case 11:
                context$1$0.t1 = _regeneratorRuntime;
                context$1$0.t2 = CONFIG_FILE;
                context$1$0.next = 15;
                return _regeneratorRuntime.awrap((0, _fsPromise.readFile)(EXAMPLE_CONFIG_FILE));

            case 15:
                context$1$0.t3 = context$1$0.sent;
                context$1$0.t4 = (0, _fsPromise.writeFile)(context$1$0.t2, context$1$0.t3);
                context$1$0.next = 19;
                return context$1$0.t1.awrap.call(context$1$0.t1, context$1$0.t4);

            case 19:
                context$1$0.next = 21;
                return _regeneratorRuntime.awrap(before());

            case 21:
                return context$1$0.abrupt('return');

            case 22:
                config.bindaddress = ADDRESS;
                config.port = PORT;
                _showdownCommands.commands.forcelogin = function (target, room, user) {
                    user.forceRename(target, true);
                };
                require('../showdown/app');

            case 26:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this, [[3, 7]]);
});

describe('utils', function () {
    describe('toId', function () {
        it('should deserialize to identifier', function () {
            (0, _assert.strictEqual)((0, _utils.toId)('Pokémon Black-2'), 'pokmonblack2');
        });
    });

    describe('toRoomId', function () {
        it('should deserialize to room identifier', function () {
            (0, _assert.strictEqual)((0, _utils.toRoomId)('Pokémon Black-2'), 'pokmonblack-2');
        });
    });
});

describe('Room', function () {
    describe('#equals', function () {
        it('should compare identical rooms as equal', function () {
            (0, _assert2['default'])(new _room2['default']('Pokémon Black-2').equals('PokmoNB Lack-2'));
        });

        it('should not compare not identical rooms as equal', function () {
            (0, _assert2['default'])(!new _room2['default']('Pokémon Black-2').equals('PokmoNB Lack2'));
        });
    });
});

describe('Client', function () {
    function connect() {
        var client;
        return _regeneratorRuntime.async(function connect$(context$2$0) {
            while (1) switch (context$2$0.prev = context$2$0.next) {
                case 0:
                    client = new _index2['default']();
                    context$2$0.next = 3;
                    return _regeneratorRuntime.awrap(client.connect({ host: ADDRESS, port: PORT }));

                case 3:
                    context$2$0.next = 5;
                    return _regeneratorRuntime.awrap(client._loginPromise);

                case 5:
                    return context$2$0.abrupt('return', client);

                case 6:
                case 'end':
                    return context$2$0.stop();
            }
        }, null, this);
    }

    describe('#connect', function () {
        it('should connect', function callee$2$0() {
            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                while (1) switch (context$3$0.prev = context$3$0.next) {
                    case 0:
                        ;context$3$0.next = 3;
                        return _regeneratorRuntime.awrap(connect());

                    case 3:
                        context$3$0.sent.disconnect();

                    case 4:
                    case 'end':
                        return context$3$0.stop();
                }
            }, null, _this);
        });
    });

    describe('#send', function () {
        it('should send commands', function callee$2$0(done) {
            var connection;
            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                while (1) switch (context$3$0.prev = context$3$0.next) {
                    case 0:
                        context$3$0.next = 2;
                        return _regeneratorRuntime.awrap(connect());

                    case 2:
                        connection = context$3$0.sent;

                        connection.send('forcelogin', 'test');
                        connection.once('raw-updateuser', function (result) {
                            if (result.split('|')[0] === 'test') {
                                connection.disconnect();
                                done();
                            }
                        });

                    case 5:
                    case 'end':
                        return context$3$0.stop();
                }
            }, null, _this);
        });
    });

    describe('#say', function () {
        it('should output text', function callee$2$0() {
            var connections, _connections, sender, receiver, initPromises, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step, MESSAGE, messagePromise, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, connection;

            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                while (1) switch (context$3$0.prev = context$3$0.next) {
                    case 0:
                        context$3$0.next = 2;
                        return _regeneratorRuntime.awrap(_Promise.all([connect(), connect()]));

                    case 2:
                        connections = context$3$0.sent;
                        _connections = _slicedToArray(connections, 2);
                        sender = _connections[0];
                        receiver = _connections[1];

                        sender.send('forcelogin', 'test0');
                        receiver.send('forcelogin', 'test1');
                        initPromises = [];
                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        context$3$0.prev = 12;

                        _loop = function () {
                            var connection = _step.value;

                            connection.joinRoom('lobby');
                            initPromises.push(new _Promise(function (resolve) {
                                connection.once('raw-init', resolve);
                            }));
                        };

                        for (_iterator = _getIterator(connections); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                            _loop();
                        }
                        context$3$0.next = 21;
                        break;

                    case 17:
                        context$3$0.prev = 17;
                        context$3$0.t0 = context$3$0['catch'](12);
                        _didIteratorError = true;
                        _iteratorError = context$3$0.t0;

                    case 21:
                        context$3$0.prev = 21;
                        context$3$0.prev = 22;

                        if (!_iteratorNormalCompletion && _iterator['return']) {
                            _iterator['return']();
                        }

                    case 24:
                        context$3$0.prev = 24;

                        if (!_didIteratorError) {
                            context$3$0.next = 27;
                            break;
                        }

                        throw _iteratorError;

                    case 27:
                        return context$3$0.finish(24);

                    case 28:
                        return context$3$0.finish(21);

                    case 29:
                        context$3$0.next = 31;
                        return _regeneratorRuntime.awrap(_Promise.all(initPromises));

                    case 31:
                        MESSAGE = 'Hello, world!';

                        sender.say(MESSAGE);

                        messagePromise = new _Promise(function (resolve) {
                            receiver.once('message', function (message) {
                                if (!message.user.equals('test0')) return;
                                (0, _assert.strictEqual)(message.text, MESSAGE);
                                resolve();
                            });
                        });
                        context$3$0.next = 36;
                        return _regeneratorRuntime.awrap(messagePromise);

                    case 36:
                        _iteratorNormalCompletion2 = true;
                        _didIteratorError2 = false;
                        _iteratorError2 = undefined;
                        context$3$0.prev = 39;

                        for (_iterator2 = _getIterator(connections); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            connection = _step2.value;

                            connection.disconnect();
                        }
                        context$3$0.next = 47;
                        break;

                    case 43:
                        context$3$0.prev = 43;
                        context$3$0.t1 = context$3$0['catch'](39);
                        _didIteratorError2 = true;
                        _iteratorError2 = context$3$0.t1;

                    case 47:
                        context$3$0.prev = 47;
                        context$3$0.prev = 48;

                        if (!_iteratorNormalCompletion2 && _iterator2['return']) {
                            _iterator2['return']();
                        }

                    case 50:
                        context$3$0.prev = 50;

                        if (!_didIteratorError2) {
                            context$3$0.next = 53;
                            break;
                        }

                        throw _iteratorError2;

                    case 53:
                        return context$3$0.finish(50);

                    case 54:
                        return context$3$0.finish(47);

                    case 55:
                    case 'end':
                        return context$3$0.stop();
                }
            }, null, _this, [[12, 17, 21, 29], [22,, 24, 28], [39, 43, 47, 55], [48,, 50, 54]]);
        });

        it('should be able to handle flood', function callee$2$0() {
            var connections, _connections2, sender, receiver, initPromises, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _loop2, _iterator3, _step3, MESSAGE, MESSAGE_COUNT, i, messagesPromise, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, connection;

            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                while (1) switch (context$3$0.prev = context$3$0.next) {
                    case 0:
                        this.timeout(6000);
                        context$3$0.next = 3;
                        return _regeneratorRuntime.awrap(_Promise.all([connect(), connect()]));

                    case 3:
                        connections = context$3$0.sent;
                        _connections2 = _slicedToArray(connections, 2);
                        sender = _connections2[0];
                        receiver = _connections2[1];

                        sender.send('forcelogin', 'test2');
                        receiver.send('forcelogin', 'test3');

                        initPromises = [];
                        _iteratorNormalCompletion3 = true;
                        _didIteratorError3 = false;
                        _iteratorError3 = undefined;
                        context$3$0.prev = 13;

                        _loop2 = function () {
                            var connection = _step3.value;

                            connection.joinRoom('lobby');
                            initPromises.push(new _Promise(function (resolve) {
                                connection.once('raw-init', resolve);
                            }));
                        };

                        for (_iterator3 = _getIterator(connections); !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                            _loop2();
                        }
                        context$3$0.next = 22;
                        break;

                    case 18:
                        context$3$0.prev = 18;
                        context$3$0.t0 = context$3$0['catch'](13);
                        _didIteratorError3 = true;
                        _iteratorError3 = context$3$0.t0;

                    case 22:
                        context$3$0.prev = 22;
                        context$3$0.prev = 23;

                        if (!_iteratorNormalCompletion3 && _iterator3['return']) {
                            _iterator3['return']();
                        }

                    case 25:
                        context$3$0.prev = 25;

                        if (!_didIteratorError3) {
                            context$3$0.next = 28;
                            break;
                        }

                        throw _iteratorError3;

                    case 28:
                        return context$3$0.finish(25);

                    case 29:
                        return context$3$0.finish(22);

                    case 30:
                        context$3$0.next = 32;
                        return _regeneratorRuntime.awrap(_Promise.all(initPromises));

                    case 32:
                        MESSAGE = 'Hello, world!';
                        MESSAGE_COUNT = 10;

                        for (i = 0; i < MESSAGE_COUNT; i++) {
                            sender.say(MESSAGE + i);
                        }

                        messagesPromise = new _Promise(function (resolve) {
                            var received = 0;
                            receiver.on('message', function (message) {
                                if (!message.user.equals('test2')) return;
                                (0, _assert.strictEqual)(message.text, MESSAGE + received);
                                received += 1;
                                if (received > MESSAGE_COUNT) {
                                    throw new Error('Got more than ' + MESSAGE_COUNT + ' messages.');
                                }
                                if (received === MESSAGE_COUNT) {
                                    resolve();
                                }
                            });
                        });
                        context$3$0.next = 38;
                        return _regeneratorRuntime.awrap(messagesPromise);

                    case 38:
                        _iteratorNormalCompletion4 = true;
                        _didIteratorError4 = false;
                        _iteratorError4 = undefined;
                        context$3$0.prev = 41;

                        for (_iterator4 = _getIterator(connections); !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                            connection = _step4.value;

                            connection.disconnect();
                        }
                        context$3$0.next = 49;
                        break;

                    case 45:
                        context$3$0.prev = 45;
                        context$3$0.t1 = context$3$0['catch'](41);
                        _didIteratorError4 = true;
                        _iteratorError4 = context$3$0.t1;

                    case 49:
                        context$3$0.prev = 49;
                        context$3$0.prev = 50;

                        if (!_iteratorNormalCompletion4 && _iterator4['return']) {
                            _iterator4['return']();
                        }

                    case 52:
                        context$3$0.prev = 52;

                        if (!_didIteratorError4) {
                            context$3$0.next = 55;
                            break;
                        }

                        throw _iteratorError4;

                    case 55:
                        return context$3$0.finish(52);

                    case 56:
                        return context$3$0.finish(49);

                    case 57:
                    case 'end':
                        return context$3$0.stop();
                }
            }, null, this, [[13, 18, 22, 30], [23,, 25, 29], [41, 45, 49, 57], [50,, 52, 56]]);
        });
    });
});
//# sourceMappingURL=_test.js.map