/**
 * Message received in a chat.
 */
"use strict";

var _createClass = require("babel-runtime/helpers/create-class")["default"];

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

Object.defineProperty(exports, "__esModule", {
    value: true
});

var ChatMessage = (function () {
    function ChatMessage(room, user, text) {
        _classCallCheck(this, ChatMessage);

        this.room = room;
        this.user = user;
        this.text = text;
    }

    _createClass(ChatMessage, [{
        key: "reply",

        /**
         * Replies to a given message in a given room.
         *
         * @param {string} message - message to say.
         */
        value: function reply(answer) {
            this.room.say(answer);
        }
    }]);

    return ChatMessage;
})();

exports.ChatMessage = ChatMessage;

/**
 * Message received in a private message.
 */

var PrivateMessage = (function () {
    function PrivateMessage(user, text) {
        _classCallCheck(this, PrivateMessage);

        this.user = user;
        this.text = text;
    }

    _createClass(PrivateMessage, [{
        key: "reply",

        /**
         * Replies to a given message in a PM.
         *
         * @param {string} message - message to say.
         */
        value: function reply(answer) {
            this.user.pm(answer);
        }
    }]);

    return PrivateMessage;
})();

exports.PrivateMessage = PrivateMessage;
//# sourceMappingURL=messages.js.map