'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _utils = require('./utils');

/**
 * Represents a room.
 */

var Room = (function () {
    function Room(name, client) {
        _classCallCheck(this, Room);

        this.name = name;
        this.client = client;
    }

    _createClass(Room, [{
        key: 'toString',

        /**
         * Returns room's name.
         */
        value: function toString() {
            return this.name;
        }
    }, {
        key: 'equals',

        /**
         * Compares user for equality by identifier with other user.
         *
         * @param {string|User} otherRoom - Other room to compare with.
         *     If it's a string, it's considered to be an room name.
         */
        value: function equals(otherRoom) {
            if (typeof otherRoom === 'string') {
                otherRoom = new Room(otherRoom);
            }
            if (otherRoom instanceof Room) {
                return this.id === otherRoom.id;
            }
            return false;
        }
    }, {
        key: 'say',

        /**
         * Says a message in a room.
         *
         * @param {string} message - message to say.
         */
        value: function say(message) {
            this.client.say(message, this.name);
        }
    }, {
        key: 'id',

        /**
         * Returns a room id.
         */
        get: function get() {
            return (0, _utils.toRoomId)(this.name);
        }
    }]);

    return Room;
})();

exports['default'] = Room;
module.exports = exports['default'];
//# sourceMappingURL=room.js.map