'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _utils = require('./utils');

/**
 * Represents a particular user.
 */

var User = (function () {
    function User(nick, client) {
        _classCallCheck(this, User);

        this.nick = nick;
        this.client = client;
    }

    _createClass(User, [{
        key: 'toString',

        /**
         * Returns user's name.
         */
        value: function toString() {
            return this.nick;
        }
    }, {
        key: 'equals',

        /**
         * Compares a user for equality by identifier with other user.
         *
         * @param {string|User} otherUser - Other user to compare with.
         *     If it's a string, it's considered to be an user name.
         */
        value: function equals(otherUser) {
            if (typeof otherUser === 'string') {
                otherUser = new User(otherUser);
            }
            if (otherUser instanceof User) {
                return this.id === otherUser.id;
            }
            return false;
        }
    }, {
        key: 'pm',

        /**
         * PMs a user with a message.
         *
         * @param {string} message - message to send to an user.
         */
        value: function pm(message) {
            if (message.charAt(0) === '/') {
                message = '/' + message;
            }
            this.client.send('pm', (0, _utils.toId)(this.id) + ',' + message);
        }
    }, {
        key: 'id',

        /**
         * Returns a user id.
         */
        get: function get() {
            return (0, _utils.toId)(this.nick);
        }
    }]);

    return User;
})();

exports['default'] = User;
module.exports = exports['default'];
//# sourceMappingURL=user.js.map